<?php
ini_set('display_errors', 1);
define("NO_KEEP_STATISTIC", true);
define("NOT_CHECK_PERMISSIONS", true);
require($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/include/prolog_before.php");

if (!CModule::IncludeModule("sale"))
    die('Can\'t include module "Sale"');

$sprypaylibPath = $_SERVER['DOCUMENT_ROOT'].'/bitrix/tools/sprypaylib';
if (file_exists($sprypaylibPath.'/SprypayNotificationValidator.php'))
    require_once($sprypaylibPath.'/SprypayNotificationValidator.php');
else
    die('SpryPay: sprypaylib not found');

if ($_SERVER['REQUEST_METHOD'] == 'GET')
    $rawIpnData = $_GET;
elseif ($_SERVER['REQUEST_METHOD'] == 'POST')
    $rawIpnData = $_POST;
else
    die('Unknown request method '.$_SERVER['REQUEST_METHOD']);

$validator = new SprypayNotificationValidator();
try {
    $validator->spParams = $rawIpnData;
} catch (SprypayException $e) {
    die($e->getMessage());
}

$notificationData = $validator->getNotificationData();
$orderId = (int) $notificationData['shopPaymentId'];
if (!($order = CSaleOrder::GetByID($orderId)))
    die('Order # '.$orderId.' not found');

CSalePaySystemAction::InitParamArrays($order, $order["ID"]);

$shopId     = CSalePaySystemAction::GetParamValue("SPRYPAY_SHOP_ID");
$shopSecret = CSalePaySystemAction::GetParamValue("SPRYPAY_SHOP_SECRET");
$amount     = CSalePaySystemAction::GetParamValue("SHOULD_PAY");
$currency   = strtolower(CSalePaySystemAction::GetParamValue("CURRENCY"));
$userEmail  = CSalePaySystemAction::GetParamValue("BUYER_EMAIL");
$feePayer   = CSalePaySystemAction::GetParamValue("SPRYPAY_FEE_PAYER");

if (!$validator->validateShopId($shopId))
    die('Invalid shop id: '.$notificationData['shopId']);

if (!$validator->validateAmount($amount))
    die('Invalid amount: '.$notificationData['amount']);

if (!$validator->validateCurrency($currency))
    die('Invalid currency: '.$notificationData['currency']);

if (!$validator->validateFeePayer($feePayer))
    die('Invalid fee payer: '.$notificationData['takeFeeFrom']);

if (!$validator->validateControlSum($shopSecret))
    die('Invalid control sum: '.$notificationData['hashString']);

$message = 'SpryPay payment '.$notificationData['paymentId'].' ('.$notificationData['balanceAmount'].' '.$notificationData['balanceCurrency'].') was enrolled to Sprypay balance in '.$notificationData['enrollDateTime'];

if ($order["PAYED"] != "Y") {
    CSaleOrder::PayOrder($order["ID"], "Y");
    $arFields = array(
        "PS_STATUS" => "Y",
        "PS_STATUS_CODE" => 'ok',
        "PS_STATUS_DESCRIPTION" => 'success',
        "PS_STATUS_MESSAGE" => $message,
        "PS_SUM" => $amount,
        "PS_CURRENCY" => $currency,
        "PS_RESPONSE_DATE" => Date(CDatabase::DateFormatToPHP(CLang::GetDateFormat("FULL", LANG))),
    );

    CSaleOrder::Update($order["ID"], $arFields);
    echo $validator->confirmNotification();
} else
    die('Order # '.$orderId.' was already performed');
require($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/include/epilog_after.php");
?>
